<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="150px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('mall.consigneeName')" prop="realName">
        <el-input v-model="formData.realName" :placeholder="t('mall.pleaseEnterConsigneeName')" />
      </el-form-item>
      <el-form-item :label="t('mall.consigneePhone')" prop="phone">
        <el-input v-model="formData.phone" :placeholder="t('mall.pleaseEnterConsigneePhone')" />
      </el-form-item>
      <el-form-item :label="t('mall.consigneeAddress')" prop="address">
        <el-input v-model="formData.address" :placeholder="t('mall.pleaseEnterConsigneeProvince')" />
      </el-form-item>
      <!-- <el-form-item label="收货人所在市" prop="city">
        <el-input v-model="formData.city" placeholder="请输入收货人所在市" />
      </el-form-item>
      <el-form-item label="收货人所在区" prop="district">
        <el-input v-model="formData.district" placeholder="请输入收货人所在区" />
      </el-form-item> -->
      <el-form-item :label="t('mall.consigneeDetailedAddress')" prop="detail">
        <el-input v-model="formData.detail" :placeholder="t('mall.consigneeDetailedAddressCannotBeEmpty')" />
      </el-form-item>
      <el-form-item :label="t('mall.isDefault')" prop="isDefault">
         <el-radio-group v-model="formData.isDefault">
            <el-radio :label="1">{{t('common.yes')}}</el-radio>
            <el-radio :label="0">{{t('common.no')}}</el-radio>
          </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{t('common.confirm')}}</el-button>
      <el-button @click="dialogVisible = false">{{t('common.cancel')}}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as UserAddressApi from '@/api/member/userAddress'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  uid: undefined,
  realName: undefined,
  phone: undefined,
  province: undefined,
  city: undefined,
  cityId: undefined,
  district: undefined,
  detail: undefined,
  postCode: undefined,
  longitude: undefined,
  latitude: undefined,
  isDefault: undefined,
  address: ''
})
const formRules = reactive({
  realName: [{ required: true, message: t('mall.consigneeNameCannotBeEmpty'), trigger: 'blur' }],
  phone: [{ required: true, message: t('mall.consigneePhoneCannotBeEmpty'), trigger: 'blur' }],
  address: [{ required: true, message: t('mall.consigneeAddressCannotBeEmpty'), trigger: 'blur' }],
  detail: [{ required: true, message: t('mall.consigneeDetailedAddressCannotBeEmpty'), trigger: 'blur' }],
  isDefault: [{ required: true, message: t('mall.isDefaultCannotBeEmpty'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await UserAddressApi.getUserAddress(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as UserAddressApi.UserAddressVO
    if (formType.value === 'create') {
      await UserAddressApi.createUserAddress(data)
      message.success(t('common.createSuccess'))
    } else {
      await UserAddressApi.updateUserAddress(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    uid: undefined,
    realName: undefined,
    phone: undefined,
    province: undefined,
    city: undefined,
    cityId: undefined,
    district: undefined,
    detail: undefined,
    postCode: undefined,
    longitude: undefined,
    latitude: undefined,
    isDefault: undefined,
    address: ''
  }
  formRef.value?.resetFields()
}
</script>
